#ifndef KYLIN_USERNAME_CHECK_H
#define KYLIN_USERNAME_CHECK_H

#ifdef __cplusplus
extern "C" {
#endif

#define CHECK_SUCCESS        0
#define LENGTH_ERROR        -1
#define REGEX_ERROR         -2
#define RESERVED_ERROR      -3
#define NAME_ERROR          -4
#define OPEN_RESERVED_NAMES_ERROR          -5

int allow_badname = 0;

/* 
 * Check whether username  is valid
 *
 * Arguments
 * name: username to check
 * reserve: whether check reserve names, 0 means NOT check
 * 
 * Return value
 *    0:valid name	
 *  < 0:invalid name
 * 
 */
int kylin_username_check(const char *name, int reserve);


/*
 * Return string descibing error code
 * 
 * Argument
 * err_num: return value from kylin_username_check function
 */
char *kylin_username_strerror(int err_num);

#ifdef __cplusplus
}
#endif

#endif /* KYLIN_USERNAME_CHECK_H */
